Index: django/http/__init__.py
===================================================================
--- django/http/__init__.py	(revision 2605)
+++ django/http/__init__.py	(working copy)
@@ -146,13 +146,19 @@
         cookiedict[key] = c.get(key).value
     return cookiedict
 
-class HttpResponse:
+class HttpResponse(object):
     "A basic HTTP response, with content and dictionary-accessed headers"
     def __init__(self, content='', mimetype=None):
+        from django.conf.settings import DEFAULT_CONTENT_TYPE, DEFAULT_CHARSET
+        self._charset = DEFAULT_CHARSET
         if not mimetype:
-            from django.conf import settings
-            mimetype = "%s; charset=%s" % (settings.DEFAULT_CONTENT_TYPE, settings.DEFAULT_CHARSET)
-        self.content = content
+            mimetype = "%s; charset=%s" % (DEFAULT_CONTENT_TYPE, DEFAULT_CHARSET)
+        if hasattr(content,'__iter__'):
+            self.iterator = content
+            self._is_string = False
+        else:
+            self.iterator = [content]
+            self._is_string = True
         self.headers = {'Content-Type':mimetype}
         self.cookies = SimpleCookie()
         self.status_code = 200
@@ -196,25 +202,32 @@
         except KeyError:
             pass
 
-    def get_content_as_string(self, encoding):
-        """
-        Returns the content as a string, encoding it from a Unicode object if
-        necessary.
-        """
-        if isinstance(self.content, unicode):
-            return self.content.encode(encoding)
-        return self.content
+    def _get_content(self):
+        content = ''.join(self.iterator)
+        if isinstance(content, unicode):
+            content = content.encode(self._charset)
+        return content
 
+    def _set_content(self, value):
+        self.iterator = [value]
+        self._is_string = True
+
+    content = property(_get_content,_set_content)
+
     # The remaining methods partially implement the file-like object interface.
     # See http://docs.python.org/lib/bltin-file-objects.html
     def write(self, content):
-        self.content += content
+        if not self._is_string:
+            raise Exception, "This %s instance is not writable"%self.__class__
+        self.iterator.append(content)
 
     def flush(self):
         pass
 
     def tell(self):
-        return len(self.content)
+        if not self._is_string:
+            raise Exception, "This %s instance cannot tell its position"%self.__class__
+        return sum(len(chunk) for chunk in self.iterator)
 
 class HttpResponseRedirect(HttpResponse):
     def __init__(self, redirect_to):
Index: django/core/handlers/wsgi.py
===================================================================
--- django/core/handlers/wsgi.py	(revision 2605)
+++ django/core/handlers/wsgi.py	(working copy)
@@ -159,6 +159,5 @@
         response_headers = response.headers.items()
         for c in response.cookies.values():
             response_headers.append(('Set-Cookie', c.output(header='')))
-        output = [response.get_content_as_string(settings.DEFAULT_CHARSET)]
         start_response(status, response_headers)
-        return output
+        return response.iterator
Index: django/core/handlers/modpython.py
===================================================================
--- django/core/handlers/modpython.py	(revision 2605)
+++ django/core/handlers/modpython.py	(working copy)
@@ -149,7 +149,8 @@
     for c in http_response.cookies.values():
         mod_python_req.headers_out.add('Set-Cookie', c.output(header=''))
     mod_python_req.status = http_response.status_code
-    mod_python_req.write(http_response.get_content_as_string(settings.DEFAULT_CHARSET))
+    for chunk in http_response.iterator:
+        mod_python_req.write(chunk)
 
 def handler(req):
     # mod_python hooks into this function.
Index: django/utils/cache.py
===================================================================
--- django/utils/cache.py	(revision 2605)
+++ django/utils/cache.py	(working copy)
@@ -74,7 +74,7 @@
         cache_timeout = settings.CACHE_MIDDLEWARE_SECONDS
     now = datetime.datetime.utcnow()
     if not response.has_header('ETag'):
-        response['ETag'] = md5.new(response.get_content_as_string('utf8')).hexdigest()
+        response['ETag'] = md5.new(response.content).hexdigest()
     if not response.has_header('Last-Modified'):
         response['Last-Modified'] = now.strftime('%a, %d %b %Y %H:%M:%S GMT')
     if not response.has_header('Expires'):
Index: django/middleware/common.py
===================================================================
--- django/middleware/common.py	(revision 2605)
+++ django/middleware/common.py	(working copy)
@@ -68,7 +68,7 @@
 
         # Use ETags, if requested.
         if settings.USE_ETAGS:
-            etag = md5.new(response.get_content_as_string(settings.DEFAULT_CHARSET)).hexdigest()
+            etag = md5.new(response.content).hexdigest()
             if request.META.get('HTTP_IF_NONE_MATCH') == etag:
                 response = http.HttpResponseNotModified()
             else: