Index: templatetags/comments.py
===================================================================
--- templatetags/comments.py	(revision 2698)
+++ templatetags/comments.py	(working copy)
@@ -2,7 +2,7 @@
 from django.contrib.comments.models import PHOTOS_REQUIRED, PHOTOS_OPTIONAL, RATINGS_REQUIRED, RATINGS_OPTIONAL, IS_PUBLIC
 from django.contrib.comments.models import MIN_PHOTO_DIMENSION, MAX_PHOTO_DIMENSION
 from django import template
-from django.core.template import loader
+from django.template import loader
 from django.core.exceptions import ObjectDoesNotExist
 from django.contrib.contenttypes.models import ContentType
 import re
@@ -77,12 +77,12 @@
 
     def render(self, context):
         from django.conf import settings
-        get_count_function = self.free and FreeComment.objects.get_count or Comment.objects.get_count
+        manager = self.free and FreeComment.objects or Comment.objects
         if self.context_var_name is not None:
             self.obj_id = template.resolve_variable(self.context_var_name, context)
-        comment_count = get_count_function(object_id__exact=self.obj_id,
-            content_type__package__label__exact=self.package,
-            content_type__python_module_name__exact=self.module, site__id__exact=settings.SITE_ID)
+        comment_count = manager.filter(object_id__exact=self.obj_id,
+            content_type__app_label__exact=self.package,
+            content_type__model__exact=self.module, site__id__exact=settings.SITE_ID).count()
         context[self.var_name] = comment_count
         return ''
 
@@ -96,7 +96,7 @@
 
     def render(self, context):
         from django.conf import settings
-        get_list_function = self.free and FreeComment.objects.get_list or Comment.objects.get_list_with_karma
+        get_list_function = self.free and FreeComment.objects.filter or Comment.objects.get_list_with_karma
         if self.context_var_name is not None:
             try:
                 self.obj_id = template.resolve_variable(self.context_var_name, context)
@@ -104,16 +104,14 @@
                 return ''
         kwargs = {
             'object_id__exact': self.obj_id,
-            'content_type__package__label__exact': self.package,
-            'content_type__python_module_name__exact': self.module,
+            'content_type__app_label__exact': self.package,
+            'content_type__model__exact': self.module,
             'site__id__exact': settings.SITE_ID,
-            'select_related': True,
-            'order_by': (self.ordering + 'submit_date',),
         }
         kwargs.update(self.extra_kwargs)
         if not self.free and settings.COMMENTS_BANNED_USERS_GROUP:
             kwargs['select'] = {'is_hidden': 'user_id IN (SELECT user_id FROM auth_users_groups WHERE group_id = %s)' % settings.COMMENTS_BANNED_USERS_GROUP}
-        comment_list = get_list_function(**kwargs)
+        comment_list = get_list_function(**kwargs).order_by(self.ordering + 'submit_date').select_related()
 
         if not self.free:
             if context.has_key('user') and not context['user'].is_anonymous():
@@ -157,7 +155,7 @@
         except ValueError: # unpack list of wrong size
             raise template.TemplateSyntaxError, "Third argument in %r tag must be in the format 'package.module'" % tokens[0]
         try:
-            content_type = ContentType.objects.get_object(package__label__exact=package, python_module_name__exact=module)
+            content_type = ContentType.objects.get(app_label__exact=package, model__exact=module)
         except ContentType.DoesNotExist:
             raise template.TemplateSyntaxError, "%r tag has invalid content-type '%s.%s'" % (tokens[0], package, module)
         obj_id_lookup_var, obj_id = None, None
@@ -237,7 +235,7 @@
         except ValueError: # unpack list of wrong size
             raise template.TemplateSyntaxError, "Third argument in %r tag must be in the format 'package.module'" % tokens[0]
         try:
-            content_type = ContentType.objects.get_object(package__label__exact=package, python_module_name__exact=module)
+            content_type = ContentType.objects.get(app_label__exact=package, model__exact=module)
         except ContentType.DoesNotExist:
             raise template.TemplateSyntaxError, "%r tag has invalid content-type '%s.%s'" % (tokens[0], package, module)
         var_name, obj_id = None, None
@@ -292,7 +290,7 @@
         except ValueError: # unpack list of wrong size
             raise template.TemplateSyntaxError, "Third argument in %r tag must be in the format 'package.module'" % tokens[0]
         try:
-            content_type = ContentType.objects.get_object(package__label__exact=package, python_module_name__exact=module)
+            content_type = ContentType.objects.get(app_label__exact=package,model__exact=module)
         except ContentType.DoesNotExist:
             raise template.TemplateSyntaxError, "%r tag has invalid content-type '%s.%s'" % (tokens[0], package, module)
         var_name, obj_id = None, None
Index: models.py
===================================================================
--- models.py	(revision 2698)
+++ models.py	(working copy)
@@ -50,7 +50,7 @@
         kwargs.setdefault('select', {})
         kwargs['select']['_karma_total_good'] = 'SELECT COUNT(*) FROM comments_karma WHERE comments_karma.comment_id=comments.id AND score=1'
         kwargs['select']['_karma_total_bad'] = 'SELECT COUNT(*) FROM comments_karma WHERE comments_karma.comment_id=comments.id AND score=-1'
-        return self.get_list(**kwargs)
+        return self.filter(**kwargs)
 
     def user_is_moderator(self, user):
         if user.is_superuser:
Index: views/comments.py
===================================================================
--- views/comments.py	(revision 2698)
+++ views/comments.py	(working copy)
@@ -90,7 +90,7 @@
     def save(self, new_data):
         today = datetime.date.today()
         c = self.get_comment(new_data)
-        for old in Comment.objects.get_list(content_type__id__exact=new_data["content_type_id"],
+        for old in Comment.objects.filter(content_type__id__exact=new_data["content_type_id"],
             object_id__exact=new_data["object_id"], user__id__exact=self.get_user_id()):
             # Check that this comment isn't duplicate. (Sometimes people post
             # comments twice by mistake.) If it is, fail silently by pretending
@@ -146,7 +146,7 @@
         # Check that this comment isn't duplicate. (Sometimes people post
         # comments twice by mistake.) If it is, fail silently by pretending
         # the comment was posted successfully.
-        for old_comment in FreeComment.objects.get_list(content_type__id__exact=new_data["content_type_id"],
+        for old_comment in FreeComment.objects.filter(content_type__id__exact=new_data["content_type_id"],
             object_id__exact=new_data["object_id"], person_name__exact=new_data["person_name"],
             submit_date__year=today.year, submit_date__month=today.month,
             submit_date__day=today.day):
@@ -202,7 +202,7 @@
         rating_range, rating_choices = [], []
     content_type_id, object_id = target.split(':') # target is something like '52:5157'
     try:
-        obj = ContentType.objects.get_object(pk=content_type_id).get_object_for_this_type(pk=object_id)
+        obj = ContentType.objects.get(pk=content_type_id).get_object_for_this_type(pk=object_id)
     except ObjectDoesNotExist:
         raise Http404, _("The comment form had an invalid 'target' parameter -- the object ID was invalid")
     option_list = options.split(',') # options is something like 'pa,ra'
@@ -285,7 +285,7 @@
     if Comment.objects.get_security_hash(options, '', '', target) != security_hash:
         raise Http404, _("Somebody tampered with the comment form (security violation)")
     content_type_id, object_id = target.split(':') # target is something like '52:5157'
-    content_type = ContentType.objects.get_object(pk=content_type_id)
+    content_type = ContentType.objects.get(pk=content_type_id)
     try:
         obj = content_type.get_object_for_this_type(pk=object_id)
     except ObjectDoesNotExist:
@@ -333,7 +333,7 @@
     if request.GET.has_key('c'):
         content_type_id, object_id = request.GET['c'].split(':')
         try:
-            content_type = ContentType.objects.get_object(pk=content_type_id)
+            content_type = ContentType.objects.get(pk=content_type_id)
             obj = content_type.get_object_for_this_type(pk=object_id)
         except ObjectDoesNotExist:
             pass