--- a/django/forms/__init__.py
+++ b/django/forms/__init__.py
@@ -361,19 +361,26 @@ class FormField:
         "Returns the HTML 'id' attribute for this form field."
         return FORM_FIELD_ID_PREFIX + self.field_name
 
+    def css_class(self):
+        readonly_label = ''
+        if self.readonly:
+            readonly_label = "Readonly"
+        return "v%s%s" % (readonly_label, self.__class__.__name__)
+
 ####################
 # GENERIC WIDGETS  #
 ####################
 
 class TextField(FormField):
     input_type = "text"
-    def __init__(self, field_name, length=30, maxlength=None, is_required=False, validator_list=[], member_name=None):
+    def __init__(self, field_name, length=30, maxlength=None, is_required=False, validator_list=[], member_name=None, readonly=False):
         self.field_name = field_name
         self.length, self.maxlength = length, maxlength
         self.is_required = is_required
         self.validator_list = [self.isValidLength, self.hasNoNewlines] + validator_list
         if member_name != None:
             self.member_name = member_name
+        self.readonly = readonly
 
     def isValidLength(self, data, form):
         if data and self.maxlength and len(data.decode(settings.DEFAULT_CHARSET)) > self.maxlength:
@@ -388,13 +395,16 @@ class TextField(FormField):
         if data is None:
             data = ''
         maxlength = ''
+        readonly = ''
         if self.maxlength:
             maxlength = 'maxlength="%s" ' % self.maxlength
+        if self.readonly:
+            readonly = 'readonly="readonly"'
         if isinstance(data, unicode):
             data = data.encode(settings.DEFAULT_CHARSET)
-        return '<input type="%s" id="%s" class="v%s%s" name="%s" size="%s" value="%s" %s/>' % \
-            (self.input_type, self.get_id(), self.__class__.__name__, self.is_required and ' required' or '',
-            self.field_name, self.length, escape(data), maxlength)
+        return '<input type="%s" id="%s" class="%s%s" name="%s" size="%s" value="%s" %s %s/>' % \
+            (self.input_type, self.get_id(), self.css_class(), self.is_required and ' required' or '',
+            self.field_name, self.length, escape(data), maxlength, readonly)
 
     def html2python(data):
         return data
@@ -404,22 +414,26 @@ class PasswordField(TextField):
     input_type = "password"
 
 class LargeTextField(TextField):
-    def __init__(self, field_name, rows=10, cols=40, is_required=False, validator_list=[], maxlength=None):
+    def __init__(self, field_name, rows=10, cols=40, is_required=False, validator_list=[], maxlength=None, readonly=False):
         self.field_name = field_name
         self.rows, self.cols, self.is_required = rows, cols, is_required
         self.validator_list = validator_list[:]
         if maxlength:
             self.validator_list.append(self.isValidLength)
             self.maxlength = maxlength
+        self.readonly = readonly
 
     def render(self, data):
         if data is None:
             data = ''
         if isinstance(data, unicode):
             data = data.encode(settings.DEFAULT_CHARSET)
-        return '<textarea id="%s" class="v%s%s" name="%s" rows="%s" cols="%s">%s</textarea>' % \
-            (self.get_id(), self.__class__.__name__, self.is_required and ' required' or '',
-            self.field_name, self.rows, self.cols, escape(data))
+        readonly = ''
+        if self.readonly:
+            readonly = 'readonly="readonly"'
+        return '<textarea id="%s" class="%s%s" name="%s" rows="%s" cols="%s" %s>%s</textarea>' % \
+            (self.get_id(), self.css_class(), self.is_required and ' required' or '',
+            self.field_name, self.rows, self.cols, readonly, escape(data))
 
 class HiddenField(FormField):
     def __init__(self, field_name, is_required=False, validator_list=[]):
@@ -431,18 +445,22 @@ class HiddenField(FormField):
             (self.get_id(), self.field_name, escape(data))
 
 class CheckboxField(FormField):
-    def __init__(self, field_name, checked_by_default=False):
+    def __init__(self, field_name, checked_by_default=False, readonly=False):
         self.field_name = field_name
         self.checked_by_default = checked_by_default
         self.is_required, self.validator_list = False, [] # because the validator looks for these
+        self.readonly = readonly
 
     def render(self, data):
         checked_html = ''
+        readonly = ''
+        if self.readonly:
+            readonly = ' disabled="disabled"'
         if data or (data is '' and self.checked_by_default):
             checked_html = ' checked="checked"'
-        return '<input type="checkbox" id="%s" class="v%s" name="%s"%s />' % \
-            (self.get_id(), self.__class__.__name__,
-            self.field_name, checked_html)
+        return '<input type="checkbox" id="%s" class="%s" name="%s"%s%s/>' % \
+            (self.get_id(), self.css_class(),
+            self.field_name, checked_html, readonly)
 
     def html2python(data):
         "Convert value from browser ('on' or '') to a Python boolean"
@@ -452,18 +470,23 @@ class CheckboxField(FormField):
     html2python = staticmethod(html2python)
 
 class SelectField(FormField):
-    def __init__(self, field_name, choices=[], size=1, is_required=False, validator_list=[], member_name=None):
+    def __init__(self, field_name, choices=[], size=1, is_required=False, validator_list=[], member_name=None, readonly=False):
         self.field_name = field_name
         # choices is a list of (value, human-readable key) tuples because order matters
         self.choices, self.size, self.is_required = choices, size, is_required
         self.validator_list = [self.isValidChoice] + validator_list
+        self.readonly = readonly
         if member_name != None:
             self.member_name = member_name
 
     def render(self, data):
-        output = ['<select id="%s" class="v%s%s" name="%s" size="%s">' % \
-            (self.get_id(), self.__class__.__name__,
-             self.is_required and ' required' or '', self.field_name, self.size)]
+        disabled = ''
+        if self.readonly:
+            disabled='disabled="disabled"'
+        output = ['<select id="%s" class="%s%s" name="%s" size="%s" %s>' % \
+            (self.get_id(), self.css_class(),
+             self.is_required and ' required' or '', self.field_name, self.size,
+             disabled)]
         str_data = str(data) # normalize to string
         for value, display_name in self.choices:
             selected_html = ''
@@ -488,12 +511,13 @@ class NullSelectField(SelectField):
     html2python = staticmethod(html2python)
 
 class RadioSelectField(FormField):
-    def __init__(self, field_name, choices=[], ul_class='', is_required=False, validator_list=[], member_name=None):
+    def __init__(self, field_name, choices=[], ul_class='', is_required=False, validator_list=[], member_name=None, readonly=False):
         self.field_name = field_name
         # choices is a list of (value, human-readable key) tuples because order matters
         self.choices, self.is_required = choices, is_required
         self.validator_list = [self.isValidChoice] + validator_list
         self.ul_class = ul_class
+        self.readonly = readonly
         if member_name != None:
             self.member_name = member_name
 
@@ -532,13 +556,16 @@ class RadioSelectField(FormField):
         str_data = str(data) # normalize to string
         for i, (value, display_name) in enumerate(self.choices):
             selected_html = ''
+            readonly = ''
             if str(value) == str_data:
                 selected_html = ' checked="checked"'
+            if self.readonly:
+                readonly = 'readonly="readonly"'
             datalist.append({
                 'value': value,
                 'name': display_name,
-                'field': '<input type="radio" id="%s" name="%s" value="%s"%s/>' % \
-                    (self.get_id() + '_' + str(i), self.field_name, value, selected_html),
+                'field': '<input type="radio" id="%s" name="%s" value="%s"%s %s/>' % \
+                    (self.get_id() + '_' + str(i), self.field_name, value, selected_html, readonly),
                 'label': '<label for="%s">%s</label>' % \
                     (self.get_id() + '_' + str(i), display_name),
             })
@@ -552,9 +579,9 @@ class RadioSelectField(FormField):
 
 class NullBooleanField(SelectField):
     "This SelectField provides 'Yes', 'No' and 'Unknown', mapping results to True, False or None"
-    def __init__(self, field_name, is_required=False, validator_list=[]):
+    def __init__(self, field_name, is_required=False, validator_list=[], readonly=False):
         SelectField.__init__(self, field_name, choices=[('1', 'Unknown'), ('2', 'Yes'), ('3', 'No')],
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def render(self, data):
         if data is None: data = '1'
@@ -605,8 +632,8 @@ class CheckboxSelectMultipleField(Select
     back into the single list that validators, renderers and save() expect.
     """
     requires_data_list = True
-    def __init__(self, field_name, choices=[], validator_list=[]):
-        SelectMultipleField.__init__(self, field_name, choices, size=1, is_required=False, validator_list=validator_list)
+    def __init__(self, field_name, choices=[], validator_list=[], readonly=False):
+        SelectMultipleField.__init__(self, field_name, choices, size=1, is_required=False, validator_list=validator_list, readonly=readonly)
 
     def prepare(self, new_data):
         # new_data has "split" this field into several fields, so flatten it
@@ -671,11 +698,11 @@ # INTEGERS/FLOATS  #
 ####################
 
 class IntegerField(TextField):
-    def __init__(self, field_name, length=10, maxlength=None, is_required=False, validator_list=[], member_name=None):
+    def __init__(self, field_name, length=10, maxlength=None, is_required=False, validator_list=[], member_name=None, readonly=False):
         validator_list = [self.isInteger] + validator_list
         if member_name is not None:
             self.member_name = member_name
-        TextField.__init__(self, field_name, length, maxlength, is_required, validator_list)
+        TextField.__init__(self, field_name, length, maxlength, is_required, validator_list, readonly)
 
     def isInteger(self, field_data, all_data):
         try:
@@ -690,37 +717,37 @@ class IntegerField(TextField):
     html2python = staticmethod(html2python)
 
 class SmallIntegerField(IntegerField):
-    def __init__(self, field_name, length=5, maxlength=5, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=5, maxlength=5, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isSmallInteger] + validator_list
-        IntegerField.__init__(self, field_name, length, maxlength, is_required, validator_list)
+        IntegerField.__init__(self, field_name, length, maxlength, is_required, validator_list, readonly)
 
     def isSmallInteger(self, field_data, all_data):
         if not -32768 <= int(field_data) <= 32767:
             raise validators.CriticalValidationError, gettext("Enter a whole number between -32,768 and 32,767.")
 
 class PositiveIntegerField(IntegerField):
-    def __init__(self, field_name, length=10, maxlength=None, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=10, maxlength=None, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isPositive] + validator_list
-        IntegerField.__init__(self, field_name, length, maxlength, is_required, validator_list)
+        IntegerField.__init__(self, field_name, length, maxlength, is_required, validator_list, readonly)
 
     def isPositive(self, field_data, all_data):
         if int(field_data) < 0:
             raise validators.CriticalValidationError, gettext("Enter a positive number.")
 
 class PositiveSmallIntegerField(IntegerField):
-    def __init__(self, field_name, length=5, maxlength=None, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=5, maxlength=None, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isPositiveSmall] + validator_list
-        IntegerField.__init__(self, field_name, length, maxlength, is_required, validator_list)
+        IntegerField.__init__(self, field_name, length, maxlength, is_required, validator_list, readonly)
 
     def isPositiveSmall(self, field_data, all_data):
         if not 0 <= int(field_data) <= 32767:
             raise validators.CriticalValidationError, gettext("Enter a whole number between 0 and 32,767.")
 
 class FloatField(TextField):
-    def __init__(self, field_name, max_digits, decimal_places, is_required=False, validator_list=[]):
+    def __init__(self, field_name, max_digits, decimal_places, is_required=False, validator_list=[], readonly=False):
         self.max_digits, self.decimal_places = max_digits, decimal_places
         validator_list = [self.isValidFloat] + validator_list
-        TextField.__init__(self, field_name, max_digits+1, max_digits+1, is_required, validator_list)
+        TextField.__init__(self, field_name, max_digits+1, max_digits+1, is_required, validator_list, readonly)
 
     def isValidFloat(self, field_data, all_data):
         v = validators.IsValidFloat(self.max_digits, self.decimal_places)
@@ -742,11 +769,12 @@ ####################
 class DatetimeField(TextField):
     """A FormField that automatically converts its data to a datetime.datetime object.
     The data should be in the format YYYY-MM-DD HH:MM:SS."""
-    def __init__(self, field_name, length=30, maxlength=None, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=30, maxlength=None, is_required=False, validator_list=[], readonly=False):
         self.field_name = field_name
         self.length, self.maxlength = length, maxlength
         self.is_required = is_required
         self.validator_list = [validators.isValidANSIDatetime] + validator_list
+        self.readonly = readonly
 
     def html2python(data):
         "Converts the field into a datetime.datetime object"
@@ -765,10 +793,10 @@ class DatetimeField(TextField):
 class DateField(TextField):
     """A FormField that automatically converts its data to a datetime.date object.
     The data should be in the format YYYY-MM-DD."""
-    def __init__(self, field_name, is_required=False, validator_list=[]):
+    def __init__(self, field_name, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidDate] + validator_list
         TextField.__init__(self, field_name, length=10, maxlength=10,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidDate(self, field_data, all_data):
         try:
@@ -789,10 +817,10 @@ class DateField(TextField):
 class TimeField(TextField):
     """A FormField that automatically converts its data to a datetime.time object.
     The data should be in the format HH:MM:SS or HH:MM:SS.mmmmmm."""
-    def __init__(self, field_name, is_required=False, validator_list=[]):
+    def __init__(self, field_name, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidTime] + validator_list
         TextField.__init__(self, field_name, length=8, maxlength=8,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidTime(self, field_data, all_data):
         try:
@@ -823,10 +851,10 @@ ####################
 
 class EmailField(TextField):
     "A convenience FormField for validating e-mail addresses"
-    def __init__(self, field_name, length=50, maxlength=75, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=50, maxlength=75, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidEmail] + validator_list
         TextField.__init__(self, field_name, length, maxlength=maxlength,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidEmail(self, field_data, all_data):
         try:
@@ -836,10 +864,10 @@ class EmailField(TextField):
 
 class URLField(TextField):
     "A convenience FormField for validating URLs"
-    def __init__(self, field_name, length=50, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=50, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidURL] + validator_list
         TextField.__init__(self, field_name, length=length, maxlength=200,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidURL(self, field_data, all_data):
         try:
@@ -848,10 +876,10 @@ class URLField(TextField):
             raise validators.CriticalValidationError, e.messages
 
 class IPAddressField(TextField):
-    def __init__(self, field_name, length=15, maxlength=15, is_required=False, validator_list=[]):
+    def __init__(self, field_name, length=15, maxlength=15, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidIPAddress] + validator_list
         TextField.__init__(self, field_name, length=length, maxlength=maxlength,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidIPAddress(self, field_data, all_data):
         try:
@@ -869,7 +897,7 @@ ####################
 
 class FilePathField(SelectField):
     "A SelectField whose choices are the files in a given directory."
-    def __init__(self, field_name, path, match=None, recursive=False, is_required=False, validator_list=[]):
+    def __init__(self, field_name, path, match=None, recursive=False, is_required=False, validator_list=[], readonly=False):
         import os
         if match is not None:
             import re
@@ -888,14 +916,14 @@ class FilePathField(SelectField):
                         choices.append((full_file, f))
             except OSError:
                 pass
-        SelectField.__init__(self, field_name, choices, 1, is_required, validator_list)
+        SelectField.__init__(self, field_name, choices, 1, is_required, validator_list, readonly)
 
 class PhoneNumberField(TextField):
     "A convenience FormField for validating phone numbers (e.g. '630-555-1234')"
-    def __init__(self, field_name, is_required=False, validator_list=[]):
+    def __init__(self, field_name, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidPhone] + validator_list
         TextField.__init__(self, field_name, length=12, maxlength=12,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidPhone(self, field_data, all_data):
         try:
@@ -905,10 +933,10 @@ class PhoneNumberField(TextField):
 
 class USStateField(TextField):
     "A convenience FormField for validating U.S. states (e.g. 'IL')"
-    def __init__(self, field_name, is_required=False, validator_list=[]):
+    def __init__(self, field_name, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isValidUSState] + validator_list
         TextField.__init__(self, field_name, length=2, maxlength=2,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isValidUSState(self, field_data, all_data):
         try:
@@ -925,10 +953,10 @@ class USStateField(TextField):
 
 class CommaSeparatedIntegerField(TextField):
     "A convenience FormField for validating comma-separated integer fields"
-    def __init__(self, field_name, maxlength=None, is_required=False, validator_list=[]):
+    def __init__(self, field_name, maxlength=None, is_required=False, validator_list=[], readonly=False):
         validator_list = [self.isCommaSeparatedIntegerList] + validator_list
         TextField.__init__(self, field_name, length=20, maxlength=maxlength,
-            is_required=is_required, validator_list=validator_list)
+            is_required=is_required, validator_list=validator_list, readonly=readonly)
 
     def isCommaSeparatedIntegerList(self, field_data, all_data):
         try: