Index: docs/tutorial01.txt
===================================================================
--- docs/tutorial01.txt	(revision 2868)
+++ docs/tutorial01.txt	(working copy)
@@ -69,7 +69,7 @@
     * ``urls.py``: The URL declarations for this Django project; a "table of
       contents" of your Django-powered site.
 
-.. _more on packages: http://docs.python.org/tut/node8.html#packages
+.. _more about packages: http://docs.python.org/tut/node8.html#packages
 
 The development server
 ----------------------
Index: docs/request_response.txt
===================================================================
--- docs/request_response.txt	(revision 2868)
+++ docs/request_response.txt	(working copy)
@@ -102,7 +102,7 @@
     ``AuthenticationMiddleware`` activated. For more, see
     `Authentication in Web requests`_.
 
-    .. Authentication in Web requests: http://www.djangoproject.com/documentation/authentication/#authentication-in-web-requests
+    .. _Authentication in Web requests: http://www.djangoproject.com/documentation/authentication/#authentication-in-web-requests
 
 ``session``
     A readable-and-writable, dictionary-like object that represents the current
Index: docs/db-api.txt
===================================================================
--- docs/db-api.txt	(revision 2868)
+++ docs/db-api.txt	(working copy)
@@ -1070,7 +1070,7 @@
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 Django offers a powerful and intuitive way to "follow" relationships in
-lookups, taking care of the SQL ``JOIN``s for you automatically, behind the
+lookups, taking care of the SQL ``JOIN``\s for you automatically, behind the
 scenes. To span a relationship, just use the field name of related fields
 across models, separated by double underscores, until you get to the field you
 want.
Index: docs/model-api.txt
===================================================================
--- docs/model-api.txt	(revision 2868)
+++ docs/model-api.txt	(working copy)
@@ -52,7 +52,7 @@
     * The name of the table, ``myapp_person``, is automatically derived from
       some model metadata but can be overridden. See _`Table names` below.
     * An ``id`` field is added automatically, but this behavior can be
-      overriden. See _`Automatic primary key fields` below.
+      overriden. See `Automatic primary key fields`_ below.
     * The ``CREATE TABLE`` SQL in this example is formatted using PostgreSQL
       syntax, but it's worth noting Django uses SQL tailored to the database
       backend specified in your `settings file`_.
@@ -124,7 +124,7 @@
 An ``IntegerField`` that automatically increments according to available IDs.
 You usually won't need to use this directly; a primary key field will
 automatically be added to your model if you don't specify otherwise. See
-_`Automatic primary key fields`.
+`Automatic primary key fields`_.
 
 ``BooleanField``
 ~~~~~~~~~~~~~~~~
@@ -1111,7 +1111,7 @@
 isn't an ``AutoField`` and has ``editable=True``, in a single fieldset, in
 the same order as the fields are defined in the model.
 
-The ``field_options`` dictionary can have the following keys::
+The ``field_options`` dictionary can have the following keys:
 
 ``fields``
 ~~~~~~~~~~
@@ -1312,6 +1312,8 @@
 section of the database API docs, but this section specifically touches on
 model options that customize ``Manager`` behavior.
 
+.. _Retrieving objects: http://www.djangoproject.com/documentation/db_api/#retrieving-objects
+
 Manager names
 -------------
 
@@ -1401,11 +1403,11 @@
 
 ...the statement ``Book.objects.all()`` will return all books in the database.
 
-You can override a ``Manager``'s base ``QuerySet`` by overriding the
+You can override a ``Manager``\'s base ``QuerySet`` by overriding the
 ``Manager.get_query_set()`` method. ``get_query_set()`` should return a
 ``QuerySet`` with the properties you require.
 
-For example, the following model has *two* ``Manager``s -- one that returns
+For example, the following model has *two* ``Manager``\s -- one that returns
 all objects, and one that returns only the books by Roald Dahl::
 
     # First, define the Manager subclass.
Index: docs/generic_views.txt
===================================================================
--- docs/generic_views.txt	(revision 2868)
+++ docs/generic_views.txt	(working copy)
@@ -62,6 +62,8 @@
 instance; see the `database API docs`_ for more information about ``Queryset``
 objects.
 
+.. _database API docs: http://www.djangoproject.com/documentation/db_api/
+
 "Simple" generic views
 ======================
 